local e=require"gluon.web.util"
local n=require"gluon.util"
local i=require"gluon.web.model.datatypes"
local o=e.class
local s=e.instanceof
local e={}
e.FORM_NODATA=0
e.FORM_VALID=1
e.FORM_INVALID=-1
local function r(a)
local e,t,o
e,t,o=a:match('^([^%(]+)%(([^,]+),([^%)]+)%)$')
if e then
return i[e],{t,o}
end
e,t=a:match('^([^%(]+)%(([^%)]+)%)$')
if e then
return i[e],{t}
end
return i[a],{}
end
local function h(e,t)
if e then
local e,a=r(e)
assert(e,"Invalid datatype")
return e(t,unpack(a))
end
return true
end
local t=o()
e.Node=t
function t:__init__(o,a,t)
self.children={}
self.deps={}
self.title=a or""
self.description=t or""
self.name=o
self.index=nil
self.parent=nil
self.state=e.FORM_NODATA
self.package='gluon-web-model'
end
function t:append(e)
table.insert(self.children,e)
e.index=#self.children
e.parent=self
end
function t:id_suffix()
return self.name or(self.index and tostring(self.index))or'_'
end
function t:id()
local e=self.parent and self.parent:id()or"id"
return e.."."..self:id_suffix()
end
function t:reset_node()
self.state=e.FORM_NODATA
for t,e in ipairs(self.children)do
e:reset_node()
end
end
function t:parse(t)
self.state=e.FORM_VALID
for a,e in ipairs(self.children)do
e:parse(t)
end
end
function t:propagate_state()
if self.state==e.FORM_NODATA then
return
end
for a,t in ipairs(self.children)do
t:propagate_state()
if t.state==e.FORM_INVALID then
self.state=e.FORM_INVALID
end
end
end
function t:render(t,e)
if self.template then
local e=setmetatable({
self=self,
id=self:id(),
scope=e,
},{__index=e})
t.render(self.template,e,self.package)
end
end
function t:render_children(a,t)
for o,e in ipairs(self.children)do
e:render(a,t)
end
end
function t:depends(e,o)
local a
if s(e,t)then
a={[e]=o}
else
a=e
end
table.insert(self.deps,a)
end
function t:deplist(t)
local e={}
for t,a in ipairs(t or self.deps)do
local t={}
for e,a in pairs(a)do
t[e:id()]=a
end
table.insert(e,t)
end
if next(e)then
return e
end
end
function t:resolve_depends()
local e=self:resolve_node_depends()
for a,t in ipairs(self.children)do
e=e or t:resolve_depends()
end
return e
end
function t:resolve_node_depends()
if#self.deps==0 then
return false
end
for t,a in ipairs(self.deps)do
local t=true
for a,o in pairs(a)do
if a.state~=e.FORM_VALID or a.data~=o then
t=false
break
end
end
if t then return false end
end
self:reset_node()
return true
end
function t:write()
end
function t:handle()
if self.state==e.FORM_VALID then
for t,e in ipairs(self.children)do
e:handle()
end
self:write(self.data)
end
end
local a=o(t)
e.Template=a
function a:__init__(e)
t.__init__(self)
self.template=e
end
local a=o(t)
e.AbstractValue=a
function a:__init__(...)
t.__init__(self,...)
self.default=nil
self.size=nil
self.optional=false
self.template="model/valuewrapper"
self.error=false
end
function a:defaultvalue()
return self.default
end
function a:formvalue(e)
return e:formvalue(self:id())
end
function a:cfgvalue()
if self.state==e.FORM_NODATA then
return self:defaultvalue()
else
return self.data
end
end
function a:reset_node()
self.data=nil
self.error=false
self.state=e.FORM_NODATA
end
function a:parse(t)
self.data=self:formvalue(t)
if not self:validate()then
self.error=true
self.state=e.FORM_INVALID
return
end
self.state=e.FORM_VALID
end
function a:resolve_node_depends()
if self.state==e.FORM_NODATA then
return false
end
return t.resolve_node_depends(self)
end
function a:validate()
if self.data and h(self.datatype,self.data)then
return true
end
if type(self.data)=="string"and#self.data==0 then
self.data=nil
end
if self.data==nil then
return self.optional
end
return false
end
local i=o(a)
e.Value=i
function i:__init__(...)
a.__init__(self,...)
self.subtemplate="model/value"
end
local i=o(a)
e.Flag=i
function i:__init__(...)
a.__init__(self,...)
self.subtemplate="model/fvalue"
self.default=false
end
function i:formvalue(e)
return e:formvalue(self:id())~=nil
end
function i:validate()
return true
end
local i=o(a)
e.ListValue=i
function i:__init__(...)
a.__init__(self,...)
self.subtemplate="model/lvalue"
self.size=1
self.widget="select"
self.keys={}
self.entry_list={}
end
function i:value(e,t,...)
e=tostring(e)
if self.keys[e]then
return
end
self.keys[e]=true
t=t or e
table.insert(self.entry_list,{
key=e,
value=tostring(t),
deps={...},
})
end
function i:entries()
local e={unpack(self.entry_list)}
if self:cfgvalue()==nil or self.optional then
table.insert(e,1,{
key='',
value='',
deps={},
})
end
return e
end
function i:validate()
if self.keys[self.data]then
return true
end
if type(self.data)=="string"and#self.data==0 then
self.data=nil
end
if self.data==nil then
return self.optional
end
return false
end
local i=o(a)
e.MultiListValue=i
function i:__init__(...)
a.__init__(self,...)
self.subtemplate="model/mlvalue"
self.size=1
self.keys={}
self.entry_list={}
end
function i:value(e,t,...)
e=tostring(e)
if self.keys[e]then
return
end
self.keys[e]=true
self.exclusions={}
t=t or e
table.insert(self.entry_list,{
key=e,
value=tostring(t),
deps={...},
})
end
function i:entries()
local e={unpack(self.entry_list)}
return e
end
function i:validate()
for t,e in ipairs(self.data)do
if not self.keys[e]then
return false
end
end
for e,t in pairs(self.exclusions)do
if n.contains(self.data,e)then
for t,e in ipairs(t)do
if n.contains(self.data,e)then
return false
end
end
end
end
return true
end
function i:exclusive(e,t)
if not self.exclusions[e]then
self.exclusions[e]={}
end
if not self.exclusions[t]then
self.exclusions[t]={}
end
n.add_to_set(self.exclusions[e],t)
n.add_to_set(self.exclusions[t],e)
end
function i:defaultvalue()
return self.default or{}
end
function i:formvalue(e)
return e:formvaluetable(self:id())
end
local i=o(a)
e.DynamicList=i
function i:__init__(...)
a.__init__(self,...)
self.subtemplate="model/dynlist"
end
function i:defaultvalue()
local e=self.default
if type(e)=="table"then
return e
else
return{e}
end
end
function i:formvalue(e)
return e:formvaluetable(self:id())
end
function i:validate()
if self.data==nil then
self.data={}
end
if#self.data==0 then
return self.optional
end
for t,e in ipairs(self.data)do
if not h(self.datatype,e)then
return false
end
end
return true
end
local i=o(a)
e.TextValue=i
function i:__init__(...)
a.__init__(self,...)
self.subtemplate="model/tvalue"
end
local n=o(a)
e.Element=n
function n:__init__(e,t,...)
a.__init__(self,...)
self.default=nil
self.size=nil
self.optional=false
self.template=e
for e,t in pairs(t)do
self[e]=t
end
self.error=false
end
function n:parse(t)
if not self.datatype then
self.state=e.FORM_VALID
return
end
return a:parse(t)
end
function n:validate()
if not self.datatype then
return true
end
a:validate()
end
local i=o(t)
e.Section=i
function i:__init__(e,a,o)
t.__init__(self,o,e,a)
self.template="model/section"
end
function i:option(e,...)
assert(s(e,a),"class must be a descendant of AbstractValue")
local e=e(...)
self:append(e)
return e
end
function i:element(...)
local e=n(...)
self:append(e)
return e
end
local a=o(t)
e.Form=a
function a:__init__(o,a,e)
t.__init__(self,e,o,a)
self.template="model/form"
end
function a:submitstate(e)
return e:getenv("REQUEST_METHOD")=="POST"and e:formvalue(self:id())~=nil
end
function a:parse(a)
if not self:submitstate(a)then
self.state=e.FORM_NODATA
return
end
t.parse(self,a)
while self:resolve_depends()do end
self:propagate_state()
end
function a:section(e,...)
assert(s(e,i),"class must be a descendent of Section")
local e=e(...)
self:append(e)
return e
end
return e
